/** Immutable specification object for a variable. */

class ImmutableVariable(val value: Int){

  def read : (Int, ImmutableVariable) = (value, this)

  def write(v: Int) : (Unit, ImmutableVariable) = 
    ((), new ImmutableVariable(v))

  override def toString = "ImmutableVariable("+value+")"

  override def equals(that: Any) = that match{
    case iv: ImmutableVariable => iv.value == this.value
  }

  override def hashCode = value

}
