import ox.cads.experiments.Experiments
import scala.util.Random

/** Time a sample of runs for the WG Tree or JIT Tree tester on a map. */
object WGSample{
  val iters = 1 << 8 // # iterations per worker
  val reps = 1 // # repetitions per worker
  var maxKey = 20 // maximum key size
  var concMapType = "Sharded" // type of concurrent map
  val billion = 1000000000L // 1 billion
  // FIXME: set max number of configs here.
  // val maxConfigs : Long = 1L * billion // max number of configurations to
				       // consider
  val p = 4 // # workers

  def makeDatum(size: Int, random: Random) = random.nextInt(size).toString
  
  def main(args: Array[String]) = {
    var tester = "WGTree" // tester to use
    for(arg <- args) if(arg == "--JITTree") tester = "JITTree"

    // Array for results, in millis
    for(i <- 0 until 50){
      val t0 = System.nanoTime
      val test = new MapLinTest[String](
	makeDatum, "X", p, iters, reps, maxKey, 
	concMapType, tester, true, true)
      test()
      val time = System.nanoTime - t0
      println(time/1000000+" ")
    }
  }
}
